package test.article.recs.plugins.energy;

import java.io.FileNotFoundException;
import java.io.IOException;

import schedframe.resources.computing.ComputingNode;
import schedframe.resources.computing.ComputingResource;
import schedframe.resources.computing.Processor;
import schedframe.resources.computing.profiles.energy.EnergyEvent;
import schedframe.scheduling.manager.tasks.JobRegistry;

public class IntelNodeEEP extends RecsNodeBaseEEP {

	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry,
			ComputingResource resource) {
		double powerConsumption = 0;
		ComputingNode node = (ComputingNode) resource;
		
		try {
			if(jobRegistry.getRunningTasks().size() > 0) {
				powerConsumption = powerConsumption + getMeasuredPower(createQuery(jobRegistry.getRunningTasks().get(0)));
			}
			else {
				for(Processor cpu: node.getProcessors()){
					try{
						//powerConsumption = powerConsumption + cpu.getPowerInterface().getRecentPowerUsage().getValue();
					} catch (Exception e){
						
					}
				}
				try {
					powerConsumption = powerConsumption + node.getPowerInterface().getPowerConsumption(node.getPowerInterface().getPowerState());
				} catch (NoSuchFieldException e) {
				}
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return powerConsumption;
		
		/*double nodeIdle = 11.5;
		double cpuBase = 8;
		double c = 1.12;
		double f;
		double fbase;
		double papp = 0;
		double load = 0;
		
		double powerConsumption = 0;
		ComputingNode node = (ComputingNode) resource;
		
		if(jobRegistry.getRunningTasks().size() > 0) {
			ExecTask task = jobRegistry.getRunningTasks().get(0);
			try {
				load = task.getCpuCntRequest()/8;
			} catch (NoSuchFieldException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			f = node.getProcessors().get(0).getPowerInterface().getFrequency();
			fbase = node.getProcessors().get(0).getPowerInterface().getHighestPState().getFrequency();
			TaskToApp tta = new TaskToApp();
			switch(tta.getAppType(task)){
			case abinit:{
				papp = 3.3;
				break;
			}
			case c_ray:{
				papp = 4;
				break;
			}
			case fft: {
				papp = 3.5;
				break;
			}
			case lin_3gb: {
				papp = 6;
				break;
			}
			case lin_tiny: {
				papp = 2.5;
				break;
			}
			case tar: {
				papp = 3;
				break;
			}
			}
			try {
				load = getLoad(createQuery(jobRegistry.getRunningTasks().get(0)))/100;
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			powerConsumption = nodeIdle  + load * cpuBase * Math.pow(c, (f-fbase)/100) + papp;
			try {
				double temp = nodeIdle  + task.getCpuCntRequest()/8 * cpuBase * Math.pow(c, (f-fbase)/100) + papp;
				try {
					System.out.println(tta.getAppType(task).name()+":"+node.getName()+":"+task.getCpuCntRequest() +":"+powerConsumption+";"+ temp+";"+getMeasuredPower(createQuery(task)));
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			} catch (NoSuchFieldException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		else {
			for(Processor cpu: node.getProcessors()){
				try{
					//powerConsumption = powerConsumption + cpu.getPowerInterface().getRecentPowerUsage().getValue();
				} catch (Exception e){
					
				}
			}
			try {
				powerConsumption = powerConsumption + node.getPowerInterface().getPowerConsumption(node.getPowerInterface().getPowerState());
			} catch (NoSuchFieldException e) {
			}
		}
		*/
	
		/*double powerConsumption = 0;
		ComputingNode node = (ComputingNode) resource;
		if(jobRegistry.getRunningTasks().size() > 0) {
			for(Processor cpu: node.getProcessors()){
				try{
					powerConsumption = powerConsumption + cpu.getPowerInterface().getPState().getPower();
				} catch (Exception e){
					
				}
			}
		}
		try {
			powerConsumption = powerConsumption + node.getPowerInterface().getPowerConsumption(node.getPowerInterface().getPowerState());
		} catch (NoSuchFieldException e) {
		}
		System.out.println("pci:" + powerConsumption);*/
		//return powerConsumption;
	}

}
